#Include This Once

Sub NewFileInput( ByRef obj As iInput, filename As String )
	Local buf As iFileInput
	obj = Class "cFileInput"
	If Not IsInterface( obj, iInput ) Then
		MyPrint "Failed to create NewFileInput iInput for " + filename
		End
	End If
	buf = obj
	If Not IsInterface( buf, iFileInput ) Then
		MyPrint "Failed to create NewFileInput iFileInput for " + filename
		End
	End If
	buf.Open( filename )
End Sub

Sub FileInputClose( obj As iInput )
	Local buf As iFileInput
	buf = obj
	If IsObject( buf ) Then
		buf.Close()
	End If
End Sub

Class cFileInput
	Instance fileName_ As String
	Instance fh_ As Long

	Interface iInput
		Inherit IUnknown

		Method GetCharacter() As Long
			Local ch As String
			If Eof( fh_ ) Then
				Method = 0
			Else
				Get$ #fh_, 1, ch
				If ch="" Then
					Method = 0
				Else
					Method = Asc( ch )
				End If
			End If
		End Method

	End Interface

	Interface iFileInput
		Inherit IUnknown

		Method Open( filename As String )
			fileName_ = filename
			If fh_ Then Me.Close()
			fh_ = FreeFile
			Open filename_ For Binary As #fh_
		End Method

		Method Close()
			If FileAttr( #fh_, 0 ) Then Close #fh_
			fh_ = 0
		End Method
	End Interface
End Class
